<template>
	<div :id="id" class="u-block-spacing" :class="$style.block">
		<h2 class="u-heading u-heading--pre-line">{{ heading }}</h2>

		<div :class="$style.reviewSnippetWrapper">
			<MoleculeReviewSnippet :reviews="reviews.rollup" />
		</div>

		<div :class="$style.toolbar">
			<h3 class="u-font-secondary" :class="$style.heading">
				{{ headingAboveReviews }}
			</h3>

			<div :class="$style.right">
				<!-- eslint-disable-next-line vuejs-accessibility/label-has-for -->
				<label :for="`${randomId}-sort`" :class="$style.label"> Sort by </label>

				<select :id="`${randomId}-sort`" :class="$style.select" @change="sortByChanged">
					<option
						v-for="(option, index) in sortByOptions"
						:key="index"
						:value="option.value"
						:selected="option.value === sortBy"
					>
						{{ option.text }}
					</option>
				</select>
			</div>
		</div>

		<BlockListingItem v-for="(review, index) in reviews.results" :key="index" :review="review" />

		<div v-if="reviewsCount < reviews.paging.total_results" :class="$style.loadMore">
			<BaseButton type="button" size="medium" appearance="primary" :disabled="isLoading" @click.native="loadMore">
				Load more
			</BaseButton>
		</div>
	</div>
</template>

<script>
import MoleculeReviewSnippet from '@components/molecule-review-snippet';
import BlockListingItem from './-block-listing-item';

const titles = {
	Newest: 'Latest',
	Oldest: 'Oldest',
	HighestRating: 'Highest rated',
	LowestRating: 'Lowest rated',
};

export default {
	components: {
		BlockListingItem,
		MoleculeReviewSnippet,
	},

	props: {
		id: {
			type: String,
			default: null,
		},

		pageId: {
			type: String,
			default: '',
		},

		reviews: {
			type: Object,
			default: () => ({}),
		},

		sortBy: {
			type: String,
			default: 'Newest',
		},

		heading: {
			type: String,
			default: '',
		},
	},

	data: () => ({
		isLoading: false,
		randomId: Math.floor(Math.random() * 1000000000),
		sortByOptions: [
			{ text: 'Most recent', value: 'Newest' },
			{ text: 'Oldest', value: 'Oldest' },
			{ text: 'Highest rated', value: 'HighestRating' },
			{ text: 'Lowest rated', value: 'LowestRating' },
		],
	}),

	computed: {
		reviewsCount() {
			return this.reviews.results.length;
		},

		headingAboveReviews() {
			return titles[this.sortBy];
		},
	},

	methods: {
		getProductReviews(pageFrom = 0, pageSize = 9, sortBy = this.sortBy) {
			const pageId = this.pageId;

			return this.$store.dispatch('reviews/FETCH_PRODUCT_REVIEWS', {
				pageId,
				sort: sortBy,
				pageFrom,
				pageSize,
			});
		},

		async sortByChanged(e) {
			// set loading state
			this.isLoading = true;

			// get data
			const reviews = await this.getProductReviews(0, 9, e.target.value);

			// set data
			this.$emit('sortByChanged', { reviews, sortBy: e.target.value });

			// remove loading state
			this.isLoading = false;
		},

		async loadMore() {
			// set loading state
			this.isLoading = true;

			// get data
			const reviews = await this.getProductReviews(this.reviewsCount);

			// set data
			this.$emit('loadMore', reviews);

			// remove loading state
			this.isLoading = false;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.block {
	max-width: 90rem + size('s') * 2;
	padding: 0 size('s');
	margin-right: auto;
	margin-left: auto;
}

.reviewSnippetWrapper {
	display: flex;
	justify-content: center;
	margin-top: size('s') - size('m');
	margin-bottom: size('m');

	@include above('xlarge') {
		margin-top: size('s') - size('l');
		margin-bottom: size('l');
	}
}

.toolbar {
	display: flex;
	align-items: center;
	justify-content: space-between;
	margin-bottom: size('s');
}

.right {
	position: relative;
}

.label {
	position: absolute;
	top: 0.5rem;
	left: 1rem;
	width: calc(100% - 4rem);
	height: calc(100% - 1rem);
	padding: 0.5rem 0.5rem 0.5rem 1rem;
	pointer-events: none;
	background-color: color('white');
}

.select {
	height: 4rem;
	padding: 1rem 4rem 1rem 2rem;
	font-size: 1.4rem;
	background: color('white') url('~assets/images/select-arrow.svg') no-repeat 90% 45%;
	border-radius: 2rem;
}

.heading {
	@include use-text-style('heading-200');
}

.loadMore {
	text-align: center;
}
</style>
